<template>
    <div class="wrapper" v-if="Object.keys(query.query_results).length">
        <div style="text-align: center; font-size: var(--fs-title); font-weight: bold;
            color: var(--color-head); text-decoration: underline;">Query Results</div>
        <ResultTable></ResultTable>
        <!--<ResultPlotsD3 style="background-color: var(--color-bg-alt);"></ResultPlotsD3>-->
        <div class="plot-wrapper">
            <PlotItem v-if="query.query_plot_ids.scatterplot && query.query_plot_ids.scatterplot != 'DIFFERENT_UNITS'" :plot_id="query.query_plot_ids.scatterplot" plot_type="scatterplot"
            @new-scatterplot="createNewScatterplot"></PlotItem>
            <PlotItem v-if="query.query_plot_ids.histogram && query.query_plot_ids.histogram != 'DIFFERENT_UNITS'" :plot_id="query.query_plot_ids.histogram" plot_type="histogram"
            @new-histogram="createNewHistogram"></PlotItem>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useQueryStore, type ArbitraryObject } from '@/stores/query';
import ResultTable from "@/components/results/ResultTable.vue";
import PlotItem from './plot/PlotItem.vue';
import type { MetaboliteFilterRule } from '@/modules/query_module';
import { generateScatterplotFromData, generateHistogramFromData } from '@/modules/query_module';
import { useMessageStore } from '@/stores/message';

const query = useQueryStore();
const msg = useMessageStore();


const createNewScatterplot = async (m1: string, m2: string, phenotype?: string, visualizations?: MetaboliteFilterRule[], units?: ArbitraryObject) => {
    let potential_id: string|undefined = await generateScatterplotFromData(m1, m2, phenotype, visualizations, units);
    if (potential_id) {
        if (potential_id === "DIFFERENT_UNITS") {
            msg.add_message({msg: "Sorry, the scatterplot could not be drawn - different units were detected for the desired metabolite(s)!", status:400});
        }
        query.query_plot_ids.scatterplot = potential_id;
    }
}

const createNewHistogram = async(m: string, phenotype?: string, visualizations?: MetaboliteFilterRule[], units?: ArbitraryObject, histstyle?: string, bins?: number) => {
    let potential_id: string|undefined = await generateHistogramFromData(m, phenotype, visualizations, units, histstyle, bins);
    if (potential_id) {
        if (potential_id === "DIFFERENT_UNITS") {
            msg.add_message({msg: "Sorry, the histogram could not be drawn - different units were detected for the desired metabolite!", status:400});
        } else {
            query.query_plot_ids.histogram = potential_id;
        }
        
    }
}

</script>

<style scoped>

.wrapper {
    width: 100%;
    margin: 1rem auto;
}

.plot-wrapper {
    display: flex;
    align-items: center;
    flex-direction: column;
    row-gap: 4rem;
}

</style>